/**
  *******************************************************************************************************
  * @file    fm33fr0xx_fl_tsi.h
  * @author  FMSH Application Team
  * @brief   Head file of TSI FL Module
  *******************************************************************************************************
  * @attention
  *
  * Copyright (c) [2019] [Fudan Microelectronics]
  * THIS SOFTWARE is licensed under the Mulan PSL v1.
  * can use this software according to the terms and conditions of the Mulan PSL v1.
  * You may obtain a copy of Mulan PSL v1 at:
  * http://license.coscl.org.cn/MulanPSL
  * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND, EITHER EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT, MERCHANTABILITY OR FIT FOR A PARTICULAR
  * PURPOSE.
  * See the Mulan PSL v1 for more details.
  *
  *******************************************************************************************************
  */


/* Define to prevent recursive inclusion---------------------------------------------------------------*/
#ifndef __FM33FR0XX_FL_TSI_H
#define __FM33FR0XX_FL_TSI_H

#ifdef __cplusplus
extern "C" {
#endif
/* Includes -------------------------------------------------------------------------------------------*/
#include "fm33fr0xx_fl_def.h"
/** @addtogroup FM33FR0XX_FL_Driver
  * @{
  */
/* Exported types -------------------------------------------------------------------------------------*/
/** @defgroup TSI_FL_ES_INIT TSI Exported Init structures
  * @{
  */



/**
  * @}
  */
/* Exported constants ---------------------------------------------------------------------------------*/
/** @defgroup TSI_FL_Exported_Constants TSI Exported Constants
  * @{
  */

#define    TSI_IER_SEQIE_Pos                                      (2U)
#define    TSI_IER_SEQIE_Msk                                      (0x1U << TSI_IER_SEQIE_Pos)
#define    TSI_IER_SEQIE                                          TSI_IER_SEQIE_Msk

#define    TSI_IER_CHIE_Pos                                       (1U)
#define    TSI_IER_CHIE_Msk                                       (0x1U << TSI_IER_CHIE_Pos)
#define    TSI_IER_CHIE                                           TSI_IER_CHIE_Msk

#define    TSI_IER_RCUIE_Pos                                      (0U)
#define    TSI_IER_RCUIE_Msk                                      (0x1U << TSI_IER_RCUIE_Pos)
#define    TSI_IER_RCUIE                                          TSI_IER_RCUIE_Msk

#define    TSI_ISR_SEQIF_Pos                                      (2U)
#define    TSI_ISR_SEQIF_Msk                                      (0x1U << TSI_ISR_SEQIF_Pos)
#define    TSI_ISR_SEQIF                                          TSI_ISR_SEQIF_Msk

#define    TSI_ISR_CHIF_Pos                                       (1U)
#define    TSI_ISR_CHIF_Msk                                       (0x1U << TSI_ISR_CHIF_Pos)
#define    TSI_ISR_CHIF                                           TSI_ISR_CHIF_Msk

#define    TSI_ISR_RCUIF_Pos                                      (0U)
#define    TSI_ISR_RCUIF_Msk                                      (0x1U << TSI_ISR_RCUIF_Pos)
#define    TSI_ISR_RCUIF                                          TSI_ISR_RCUIF_Msk

#define    TSI_CFGR_SMPLSIZ_Pos                                   (28U)
#define    TSI_CFGR_SMPLSIZ_Msk                                   (0xfU << TSI_CFGR_SMPLSIZ_Pos)
#define    TSI_CFGR_SMPLSIZ                                       TSI_CFGR_SMPLSIZ_Msk

#define    TSI_CFGR_CONT_Pos                                      (24U)
#define    TSI_CFGR_CONT_Msk                                      (0x1U << TSI_CFGR_CONT_Pos)
#define    TSI_CFGR_CONT                                          TSI_CFGR_CONT_Msk

#define    TSI_CFGR_PROXAVGEN_Pos                                 (23U)
#define    TSI_CFGR_PROXAVGEN_Msk                                 (0x1U << TSI_CFGR_PROXAVGEN_Pos)
#define    TSI_CFGR_PROXAVGEN                                     TSI_CFGR_PROXAVGEN_Msk

#define    TSI_CFGR_PROXAVGODR_Pos                                (16U)
#define    TSI_CFGR_PROXAVGODR_Msk                                (0xfU << TSI_CFGR_PROXAVGODR_Pos)
#define    TSI_CFGR_PROXAVGODR                                    TSI_CFGR_PROXAVGODR_Msk

#define    TSI_CFGR_NORMAVGEN_Pos                                 (7U)
#define    TSI_CFGR_NORMAVGEN_Msk                                 (0x1U << TSI_CFGR_NORMAVGEN_Pos)
#define    TSI_CFGR_NORMAVGEN                                     TSI_CFGR_NORMAVGEN_Msk

#define    TSI_CFGR_NORMAVGODR_Pos                                (8U)
#define    TSI_CFGR_NORMAVGODR_Msk                                (0xfU << TSI_CFGR_NORMAVGODR_Pos)
#define    TSI_CFGR_NORMAVGODR                                    TSI_CFGR_NORMAVGODR_Msk

#define    TSI_CFGR_TRGSEL_Pos                                    (12U)
#define    TSI_CFGR_TRGSEL_Msk                                    (0xfU << TSI_CFGR_TRGSEL_Pos)
#define    TSI_CFGR_TRGSEL                                        TSI_CFGR_TRGSEL_Msk

#define    TSI_CFGR_STOPMOD_Pos                                   (6U)
#define    TSI_CFGR_STOPMOD_Msk                                   (0x1U << TSI_CFGR_STOPMOD_Pos)
#define    TSI_CFGR_STOPMOD                                       TSI_CFGR_STOPMOD_Msk

#define    TSI_CFGR_TMOD_Pos                                      (5U)
#define    TSI_CFGR_TMOD_Msk                                      (0x1U << TSI_CFGR_TMOD_Pos)
#define    TSI_CFGR_TMOD                                          TSI_CFGR_TMOD_Msk

#define    TSI_CFGR_SHIELDEN_Pos                                  (4U)
#define    TSI_CFGR_SHIELDEN_Msk                                  (0x1U << TSI_CFGR_SHIELDEN_Pos)
#define    TSI_CFGR_SHIELDEN                                      TSI_CFGR_SHIELDEN_Msk

#define    TSI_CFGR_GUARDEN_Pos                                   (3U)
#define    TSI_CFGR_GUARDEN_Msk                                   (0x1U << TSI_CFGR_GUARDEN_Pos)
#define    TSI_CFGR_GUARDEN                                       TSI_CFGR_GUARDEN_Msk

#define    TSI_CFGR_PROXMOD_Pos                                   (2U)
#define    TSI_CFGR_PROXMOD_Msk                                   (0x1U << TSI_CFGR_PROXMOD_Pos)
#define    TSI_CFGR_PROXMOD                                       TSI_CFGR_PROXMOD_Msk

#define    TSI_CFGR_PROXEN_Pos                                    (1U)
#define    TSI_CFGR_PROXEN_Msk                                    (0x1U << TSI_CFGR_PROXEN_Pos)
#define    TSI_CFGR_PROXEN                                        TSI_CFGR_PROXEN_Msk

#define    TSI_CFGR_SEN_Pos                                       (0U)
#define    TSI_CFGR_SEN_Msk                                       (0x1U << TSI_CFGR_SEN_Pos)
#define    TSI_CFGR_SEN                                           TSI_CFGR_SEN_Msk

#define    TSI_CR_START_Pos                                       (0U)
#define    TSI_CR_START_Msk                                       (0x1U << TSI_CR_START_Pos)
#define    TSI_CR_START                                           TSI_CR_START_Msk

#define    TSI_CHCFGR_PROXCHEN_Pos                                (16U)
#define    TSI_CHCFGR_PROXCHEN_Msk                                (0x3fffU << TSI_CHCFGR_PROXCHEN_Pos)
#define    TSI_CHCFGR_PROXCHEN                                    TSI_CHCFGR_PROXCHEN_Msk

#define    TSI_CHCFGR_NORMCHEN_Pos                                (0U)
#define    TSI_CHCFGR_NORMCHEN_Msk                                (0x3fffU << TSI_CHCFGR_NORMCHEN_Pos)
#define    TSI_CHCFGR_NORMCHEN                                    TSI_CHCFGR_NORMCHEN_Msk

#define    TSI_CNTR_SID_Pos                                       (16U)
#define    TSI_CNTR_SID_Msk                                       (0xfU << TSI_CNTR_SID_Pos)
#define    TSI_CNTR_SID                                           TSI_CNTR_SID_Msk

#define    TSI_CNTR_RAWCNT_Pos                                    (0U)
#define    TSI_CNTR_RAWCNT_Msk                                    (0xffffU << TSI_CNTR_RAWCNT_Pos)
#define    TSI_CNTR_RAWCNT                                        TSI_CNTR_RAWCNT_Msk

#define    TSI_CCR_PRS_Pos                                        (0U)
#define    TSI_CCR_PRS_Msk                                        (0x1U << TSI_CCR_PRS_Pos)
#define    TSI_CCR_PRS                                            TSI_CCR_PRS_Msk

#define    TSI_CCR_SCANPRD_Pos                                    (1U)
#define    TSI_CCR_SCANPRD_Msk                                    (0x1fU << TSI_CCR_SCANPRD_Pos)
#define    TSI_CCR_SCANPRD                                        TSI_CCR_SCANPRD_Msk

#define    TSI_CCR_SCANINTV_Pos                                   (8U)
#define    TSI_CCR_SCANINTV_Msk                                   (0xffU << TSI_CCR_SCANINTV_Pos)
#define    TSI_CCR_SCANINTV                                       TSI_CCR_SCANINTV_Msk

#define    TSI_CCR_SCANIDLE_Pos                                   (16U)
#define    TSI_CCR_SCANIDLE_Msk                                   (0xffU << TSI_CCR_SCANIDLE_Pos)
#define    TSI_CCR_SCANIDLE                                       TSI_CCR_SCANIDLE_Msk

#define    TSI_DMACR_DMAEN_Pos                                    (0U)
#define    TSI_DMACR_DMAEN_Msk                                    (0x1U << TSI_DMACR_DMAEN_Pos)
#define    TSI_DMACR_DMAEN                                        TSI_DMACR_DMAEN_Msk

#define    TSI_CHCFGR_RES_Pos                                     (0U)
#define    TSI_CHCFGR_RES_Msk                                     (0xfU << TSI_CHCFGR_RES_Pos)
#define    TSI_CHCFGR_RES                                         TSI_CHCFGR_RES_Msk

#define    TSI_CHCFGR_FSW_Pos                                     (4U)
#define    TSI_CHCFGR_FSW_Msk                                     (0x7U << TSI_CHCFGR_FSW_Pos)
#define    TSI_CHCFGR_FSW                                         TSI_CHCFGR_FSW_Msk

#define    TSI_CHCFGR_IDAC_Pos                                    (7U)
#define    TSI_CHCFGR_IDAC_Msk                                    (0x1U << TSI_CHCFGR_IDAC_Pos)
#define    TSI_CHCFGR_IDAC                                        TSI_CHCFGR_IDAC_Msk

#define    TSI_CHCFGR_IDAC1CFG_Pos                                (8U)
#define    TSI_CHCFGR_IDAC1CFG_Msk                                (0x7fU << TSI_CHCFGR_IDAC1CFG_Pos)
#define    TSI_CHCFGR_IDAC1CFG                                    TSI_CHCFGR_IDAC1CFG_Msk

#define    TSI_CHCFGR_IDAC2CFG_Pos                                (16U)
#define    TSI_CHCFGR_IDAC2CFG_Msk                                (0x7fU << TSI_CHCFGR_IDAC2CFG_Pos)
#define    TSI_CHCFGR_IDAC2CFG                                    TSI_CHCFGR_IDAC2CFG_Msk

#define    TSI_IDACTR_IDAC2TR_Pos                                 (8U)
#define    TSI_IDACTR_IDAC2TR_Msk                                 (0x1fU << TSI_IDACTR_IDAC2TR_Pos)
#define    TSI_IDACTR_IDAC2TR                                     TSI_IDACTR_IDAC2TR_Msk

#define    TSI_IDACTR_IDAC1TR_Pos                                 (0U)
#define    TSI_IDACTR_IDAC1TR_Msk                                 (0x1fU << TSI_IDACTR_IDAC1TR_Pos)
#define    TSI_IDACTR_IDAC1TR                                     TSI_IDACTR_IDAC1TR_Msk

#define    TSI_ANACR_RCBYP_Pos                                    (5U)
#define    TSI_ANACR_RCBYP_Msk                                    (0x1U << TSI_ANACR_RCBYP_Pos)
#define    TSI_ANACR_RCBYP                                        TSI_ANACR_RCBYP_Msk

#define    TSI_ANACR_CMPRC_Pos                                    (3U)
#define    TSI_ANACR_CMPRC_Msk                                    (0x3U << TSI_ANACR_CMPRC_Pos)
#define    TSI_ANACR_CMPRC                                        TSI_ANACR_CMPRC_Msk

#define    TSI_ANACR_CMPHS_Pos                                    (2U)
#define    TSI_ANACR_CMPHS_Msk                                    (0x1U << TSI_ANACR_CMPHS_Pos)
#define    TSI_ANACR_CMPHS                                        TSI_ANACR_CMPHS_Msk

#define    TSI_ANACR_VREFBUFCFG_Pos                               (0U)
#define    TSI_ANACR_VREFBUFCFG_Msk                               (0x3U << TSI_ANACR_VREFBUFCFG_Pos)
#define    TSI_ANACR_VREFBUFCFG                                   TSI_ANACR_VREFBUFCFG_Msk

#define    TSI_TEST_CHIDLECFG_Pos                                 (18U)
#define    TSI_TEST_CHIDLECFG_Msk                                 (0x1U << TSI_TEST_CHIDLECFG_Pos)
#define    TSI_TEST_CHIDLECFG                                     TSI_TEST_CHIDLECFG_Msk



#define    FL_TSI_CHANNEL_0                                       0x0U
#define    FL_TSI_CHANNEL_1                                       0x1U
#define    FL_TSI_CHANNEL_2                                       0x2U
#define    FL_TSI_CHANNEL_3                                       0x3U
#define    FL_TSI_CHANNEL_4                                       0x4U
#define    FL_TSI_CHANNEL_5                                       0x5U
#define    FL_TSI_CHANNEL_6                                       0x6U
#define    FL_TSI_CHANNEL_7                                       0x7U
#define    FL_TSI_CHANNEL_8                                       0x8U
#define    FL_TSI_CHANNEL_9                                       0x9U
#define    FL_TSI_CHANNEL_10                                      0xAU
#define    FL_TSI_CHANNEL_11                                      0xBU
#define    FL_TSI_CHANNEL_12                                      0xCU
#define    FL_TSI_CHANNEL_13                                      0xDU
#define    FL_TSI_CHANNEL_PROX                                    0xEU

#define    FL_TSI_BIT_CHANNEL_0                                   (0x1U << 0U)
#define    FL_TSI_BIT_CHANNEL_1                                   (0x1U << 1U)
#define    FL_TSI_BIT_CHANNEL_2                                   (0x1U << 2U)
#define    FL_TSI_BIT_CHANNEL_3                                   (0x1U << 3U)
#define    FL_TSI_BIT_CHANNEL_4                                   (0x1U << 4U)
#define    FL_TSI_BIT_CHANNEL_5                                   (0x1U << 5U)
#define    FL_TSI_BIT_CHANNEL_6                                   (0x1U << 6U)
#define    FL_TSI_BIT_CHANNEL_7                                   (0x1U << 7U)
#define    FL_TSI_BIT_CHANNEL_8                                   (0x1U << 8U)
#define    FL_TSI_BIT_CHANNEL_9                                   (0x1U << 9U)
#define    FL_TSI_BIT_CHANNEL_10                                  (0x1U << 10U)
#define    FL_TSI_BIT_CHANNEL_11                                  (0x1U << 11U)
#define    FL_TSI_BIT_CHANNEL_12                                  (0x1U << 12U)
#define    FL_TSI_BIT_CHANNEL_13                                  (0x1U << 13U)



#define    FL_TSI_SCAN_MODE_SINGLE                                (0x0U << TSI_CFGR_CONT_Pos)
#define    FL_TSI_SCAN_MODE_CONTINUOUS                            (0x1U << TSI_CFGR_CONT_Pos)


#define    FL_TSI_PROX_AVGFILTER_ORDER_2X                         (0x0U << TSI_CFGR_PROXAVGODR_Pos)
#define    FL_TSI_PROX_AVGFILTER_ORDER_4X                         (0x1U << TSI_CFGR_PROXAVGODR_Pos)
#define    FL_TSI_PROX_AVGFILTER_ORDER_8X                         (0x2U << TSI_CFGR_PROXAVGODR_Pos)
#define    FL_TSI_PROX_AVGFILTER_ORDER_16X                        (0x3U << TSI_CFGR_PROXAVGODR_Pos)


#define    FL_TSI_NORM_AVGFILTER_ORDER_2X                         (0x0U << TSI_CFGR_NORMAVGODR_Pos)
#define    FL_TSI_NORM_AVGFILTER_ORDER_4X                         (0x1U << TSI_CFGR_NORMAVGODR_Pos)
#define    FL_TSI_NORM_AVGFILTER_ORDER_8X                         (0x2U << TSI_CFGR_NORMAVGODR_Pos)
#define    FL_TSI_NORM_AVGFILTER_ORDER_16X                        (0x3U << TSI_CFGR_NORMAVGODR_Pos)


#define    FL_TSI_TRGI_RTC                                        (0x0U << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_ATIM                                       (0x1U << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_LPTIM16                                    (0x2U << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_BSTIM16                                    (0x3U << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_TAU00                                      (0x4U << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_TAU01                                      (0x5U << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_TAU02                                      (0x6U << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_TAU03                                      (0x7U << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_TAU04                                      (0x8U << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_TAU05                                      (0x9U << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_TAU06                                      (0xaU << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_TAU07                                      (0xbU << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_TAU10                                      (0xcU << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_TAU11                                      (0xdU << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_TAU12                                      (0xeU << TSI_CFGR_TRGSEL_Pos)
#define    FL_TSI_TRGI_TAU13                                      (0xfU << TSI_CFGR_TRGSEL_Pos)


#define    FL_TSI_STOP_MODE_IMMEDIATELY                           (0x0U << TSI_CFGR_STOPMOD_Pos)
#define    FL_TSI_STOP_MODE_WAIT_IDLE                             (0x1U << TSI_CFGR_STOPMOD_Pos)


#define    FL_TSI_TRIG_MODE_SOFTWARE                              (0x0U << TSI_CFGR_TMOD_Pos)
#define    FL_TSI_TRIG_MODE_TRGI                                  (0x1U << TSI_CFGR_TMOD_Pos)


#define    FL_TSI_NORM_MODE_ON_PROX_CONTINUE                      (0x0U << TSI_CFGR_PROXMOD_Pos)
#define    FL_TSI_NORM_MODE_ON_PROX_STOP                          (0x1U << TSI_CFGR_PROXMOD_Pos)


#define    FL_TSI_SAMPLE_CLK_SOURCE_FIXED_CLK                     (0x0U << TSI_CCR_PRS_Pos)
#define    FL_TSI_SAMPLE_CLK_SOURCE_PRS_CLK                       (0x1U << TSI_CCR_PRS_Pos)


#define    FL_TSI_SAMPLE_RESOLUTION_8B                            (0x0U << TSI_CHCFGR_RES_Pos)
#define    FL_TSI_SAMPLE_RESOLUTION_9B                            (0x1U << TSI_CHCFGR_RES_Pos)
#define    FL_TSI_SAMPLE_RESOLUTION_10B                           (0x2U << TSI_CHCFGR_RES_Pos)
#define    FL_TSI_SAMPLE_RESOLUTION_11B                           (0x3U << TSI_CHCFGR_RES_Pos)
#define    FL_TSI_SAMPLE_RESOLUTION_12B                           (0x4U << TSI_CHCFGR_RES_Pos)
#define    FL_TSI_SAMPLE_RESOLUTION_13B                           (0x5U << TSI_CHCFGR_RES_Pos)
#define    FL_TSI_SAMPLE_RESOLUTION_14B                           (0x6U << TSI_CHCFGR_RES_Pos)
#define    FL_TSI_SAMPLE_RESOLUTION_15B                           (0x7U << TSI_CHCFGR_RES_Pos)
#define    FL_TSI_SAMPLE_RESOLUTION_16B                           (0x8U << TSI_CHCFGR_RES_Pos)


#define    FL_TSI_SAMPLE_PSC_DIV1                                 (0x0U << TSI_CHCFGR_FSW_Pos)
#define    FL_TSI_SAMPLE_PSC_DIV2                                 (0x1U << TSI_CHCFGR_FSW_Pos)
#define    FL_TSI_SAMPLE_PSC_DIV4                                 (0x2U << TSI_CHCFGR_FSW_Pos)
#define    FL_TSI_SAMPLE_PSC_DIV8                                 (0x3U << TSI_CHCFGR_FSW_Pos)
#define    FL_TSI_SAMPLE_PSC_DIV16                                (0x4U << TSI_CHCFGR_FSW_Pos)
#define    FL_TSI_SAMPLE_PSC_DIV32                                (0x5U << TSI_CHCFGR_FSW_Pos)


#define    FL_TSI_IDAC_MODE_SINGLE                                (0x0U << TSI_CHCFGR_IDAC_Pos)
#define    FL_TSI_IDAC_MODE_DUAL                                  (0x1U << TSI_CHCFGR_IDAC_Pos)


#define    FL_TSI_COMP_RC_BANDWIDTH_1P48MHZ                       (0x0U << TSI_ANACR_CMPRC_Pos)
#define    FL_TSI_COMP_RC_BANDWIDTH_0P529MHZ                      (0x1U << TSI_ANACR_CMPRC_Pos)
#define    FL_TSI_COMP_RC_BANDWIDTH_0P4MHZ                        (0x2U << TSI_ANACR_CMPRC_Pos)
#define    FL_TSI_COMP_RC_BANDWIDTH_0P293MHZ                      (0x3U << TSI_ANACR_CMPRC_Pos)


#define    FL_TSI_BUFFER_DRIVER_STRENGTH_DISABLE                  (0x0U << TSI_ANACR_VREFBUFCFG_Pos)
#define    FL_TSI_BUFFER_DRIVER_STRENGTH_LOW                      (0x1U << TSI_ANACR_VREFBUFCFG_Pos)
#define    FL_TSI_BUFFER_DRIVER_STRENGTH_MEDIUM                   (0x2U << TSI_ANACR_VREFBUFCFG_Pos)
#define    FL_TSI_BUFFER_DRIVER_STRENGTH_HIGH                     (0x3U << TSI_ANACR_VREFBUFCFG_Pos)


#define    FL_TSI_INACTIVE_SENSOR_CONNECTION_FLOAT                (0x0U << TSI_TEST_CHIDLECFG_Pos)
#define    FL_TSI_INACTIVE_SENSOR_CONNECTION_GROUND               (0x1U << TSI_TEST_CHIDLECFG_Pos)

/**
  * @}
  */
/* Exported functions ---------------------------------------------------------------------------------*/
/** @defgroup TSI_FL_Exported_Functions TSI Exported Functions
  * @{
  */

/**
  * @brief
  * @rmtoll   IER    SEQIE    FL_TSI_EnableIT_EndOfSequence
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_EnableIT_EndOfSequence(TSI_Type *TSIx)
{
    SET_BIT(TSIx->IER, TSI_IER_SEQIE_Msk);
}

/**
  * @brief
  * @rmtoll   IER    SEQIE    FL_TSI_DisableIT_EndOfSequence
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_DisableIT_EndOfSequence(TSI_Type *TSIx)
{
    CLEAR_BIT(TSIx->IER, TSI_IER_SEQIE_Msk);
}

/**
  * @brief
  * @rmtoll   IER    SEQIE    FL_TSI_IsEnabledIT_EndOfSequence
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsEnabledIT_EndOfSequence(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->IER, TSI_IER_SEQIE_Msk) == TSI_IER_SEQIE_Msk);
}

/**
  * @brief
  * @rmtoll   IER    CHIE    FL_TSI_EnableIT_EndOfChannel
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_EnableIT_EndOfChannel(TSI_Type *TSIx)
{
    SET_BIT(TSIx->IER, TSI_IER_CHIE_Msk);
}

/**
  * @brief
  * @rmtoll   IER    CHIE    FL_TSI_DisableIT_EndOfChannel
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_DisableIT_EndOfChannel(TSI_Type *TSIx)
{
    CLEAR_BIT(TSIx->IER, TSI_IER_CHIE_Msk);
}

/**
  * @brief
  * @rmtoll   IER    CHIE    FL_TSI_IsEnabledIT_EndOfChannel
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsEnabledIT_EndOfChannel(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->IER, TSI_IER_CHIE_Msk) == TSI_IER_CHIE_Msk);
}

/**
  * @brief
  * @rmtoll   IER    RCUIE    FL_TSI_EnableIT_RawCountUpdate
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_EnableIT_RawCountUpdate(TSI_Type *TSIx)
{
    SET_BIT(TSIx->IER, TSI_IER_RCUIE_Msk);
}

/**
  * @brief
  * @rmtoll   IER    RCUIE    FL_TSI_DisableIT_RawCountUpdate
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_DisableIT_RawCountUpdate(TSI_Type *TSIx)
{
    CLEAR_BIT(TSIx->IER, TSI_IER_RCUIE_Msk);
}

/**
  * @brief
  * @rmtoll   IER    RCUIE    FL_TSI_IsEnabledIT_RawCountUpdate
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsEnabledIT_RawCountUpdate(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->IER, TSI_IER_RCUIE_Msk) == TSI_IER_RCUIE_Msk);
}

/**
  * @brief
  * @rmtoll   ISR    SEQIF    FL_TSI_IsActiveFlag_EndOfSequence
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsActiveFlag_EndOfSequence(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->ISR, TSI_ISR_SEQIF_Msk) == (TSI_ISR_SEQIF_Msk));
}

/**
  * @brief
  * @rmtoll   ISR    SEQIF    FL_TSI_ClearFlag_EndOfSequence
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_ClearFlag_EndOfSequence(TSI_Type *TSIx)
{
    WRITE_REG(TSIx->ISR, TSI_ISR_SEQIF_Msk);
}

/**
  * @brief
  * @rmtoll   ISR    CHIF    FL_TSI_IsActiveFlag_EndOfChannel
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsActiveFlag_EndOfChannel(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->ISR, TSI_ISR_CHIF_Msk) == (TSI_ISR_CHIF_Msk));
}

/**
  * @brief
  * @rmtoll   ISR    CHIF    FL_TSI_ClearFlag_EndOfChannel
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_ClearFlag_EndOfChannel(TSI_Type *TSIx)
{
    WRITE_REG(TSIx->ISR, TSI_ISR_CHIF_Msk);
}

/**
  * @brief
  * @rmtoll   ISR    RCUIF    FL_TSI_IsActiveFlag_RawCountUpdate
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsActiveFlag_RawCountUpdate(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->ISR, TSI_ISR_RCUIF_Msk) == (TSI_ISR_RCUIF_Msk));
}

/**
  * @brief
  * @rmtoll   ISR    RCUIF    FL_TSI_ClearFlag_RawCountUpdate
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_ClearFlag_RawCountUpdate(TSI_Type *TSIx)
{
    WRITE_REG(TSIx->ISR, TSI_ISR_RCUIF_Msk);
}

/**
  * @brief
  * @rmtoll   SSR        FL_TSI_ReadScanChannel
  * @param    TSIx TSI instance
  * @retval
  */
__STATIC_INLINE uint32_t FL_TSI_ReadScanChannel(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->SSR, (0xfU << 0U)) >> 0U);
}

/**
  * @brief
  * @rmtoll   CFGR    SMPLSIZ    FL_TSI_SetSampleSize
  * @param    TSIx TSI instance
  * @param    size This parameter can be one of the following values:
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetSampleSize(TSI_Type *TSIx, uint32_t size)
{
    MODIFY_REG(TSIx->CFGR, TSI_CFGR_SMPLSIZ_Msk, size);
}

/**
  * @brief
  * @rmtoll   CFGR    SMPLSIZ    FL_TSI_GetSampleSize
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  */
__STATIC_INLINE uint32_t FL_TSI_GetSampleSize(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_SMPLSIZ_Msk));
}

/**
  * @brief
  * @rmtoll   CFGR    CONT    FL_TSI_SetScanMode
  * @param    TSIx TSI instance
  * @param    mode This parameter can be one of the following values:
  *           @arg @ref FL_TSI_SCAN_MODE_SINGLE
  *           @arg @ref FL_TSI_SCAN_MODE_CONTINUOUS
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetScanMode(TSI_Type *TSIx, uint32_t mode)
{
    MODIFY_REG(TSIx->CFGR, TSI_CFGR_CONT_Msk, mode);
}

/**
  * @brief
  * @rmtoll   CFGR    CONT    FL_TSI_GetScanMode
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_SCAN_MODE_SINGLE
  *           @arg @ref FL_TSI_SCAN_MODE_CONTINUOUS
  */
__STATIC_INLINE uint32_t FL_TSI_GetScanMode(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_CONT_Msk));
}

/**
  * @brief
  * @rmtoll   CFGR    PROXAVGEN    FL_TSI_EnableProxSensorAverageFilter
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_EnableProxSensorAverageFilter(TSI_Type *TSIx)
{
    SET_BIT(TSIx->CFGR, TSI_CFGR_PROXAVGEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    PROXAVGEN    FL_TSI_DisableProxSensorAverageFilter
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_DisableProxSensorAverageFilter(TSI_Type *TSIx)
{
    CLEAR_BIT(TSIx->CFGR, TSI_CFGR_PROXAVGEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    PROXAVGEN    FL_TSI_IsEnabledProxSensorAverageFilter
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsEnabledProxSensorAverageFilter(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_PROXAVGEN_Msk) == TSI_CFGR_PROXAVGEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    PROXAVGODR    FL_TSI_SetProxSensorAverageFilterOrder
  * @param    TSIx TSI instance
  * @param    order This parameter can be one of the following values:
  *           @arg @ref FL_TSI_PROX_AVGFILTER_ORDER_2X
  *           @arg @ref FL_TSI_PROX_AVGFILTER_ORDER_4X
  *           @arg @ref FL_TSI_PROX_AVGFILTER_ORDER_8X
  *           @arg @ref FL_TSI_PROX_AVGFILTER_ORDER_16X
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetProxSensorAverageFilterOrder(TSI_Type *TSIx, uint32_t order)
{
    MODIFY_REG(TSIx->CFGR, TSI_CFGR_PROXAVGODR_Msk, order);
}

/**
  * @brief
  * @rmtoll   CFGR    PROXAVGODR    FL_TSI_GetProxSensorAverageFilterOrder
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_PROX_AVGFILTER_ORDER_2X
  *           @arg @ref FL_TSI_PROX_AVGFILTER_ORDER_4X
  *           @arg @ref FL_TSI_PROX_AVGFILTER_ORDER_8X
  *           @arg @ref FL_TSI_PROX_AVGFILTER_ORDER_16X
  */
__STATIC_INLINE uint32_t FL_TSI_GetProxSensorAverageFilterOrder(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_PROXAVGODR_Msk));
}

/**
  * @brief
  * @rmtoll   CFGR    NORMAVGEN    FL_TSI_EnableNormSensorAverageFilter
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_EnableNormSensorAverageFilter(TSI_Type *TSIx)
{
    SET_BIT(TSIx->CFGR, TSI_CFGR_NORMAVGEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    NORMAVGEN    FL_TSI_DisableNormSensorAverageFilter
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_DisableNormSensorAverageFilter(TSI_Type *TSIx)
{
    CLEAR_BIT(TSIx->CFGR, TSI_CFGR_NORMAVGEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    NORMAVGEN    FL_TSI_IsEnabledNormSensorAverageFilter
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsEnabledNormSensorAverageFilter(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_NORMAVGEN_Msk) == TSI_CFGR_NORMAVGEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    NORMAVGODR    FL_TSI_SetNormSensorAverageFilterOrder
  * @param    TSIx TSI instance
  * @param    order This parameter can be one of the following values:
  *           @arg @ref FL_TSI_NORM_AVGFILTER_ORDER_2X
  *           @arg @ref FL_TSI_NORM_AVGFILTER_ORDER_4X
  *           @arg @ref FL_TSI_NORM_AVGFILTER_ORDER_8X
  *           @arg @ref FL_TSI_NORM_AVGFILTER_ORDER_16X
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetNormSensorAverageFilterOrder(TSI_Type *TSIx, uint32_t order)
{
    MODIFY_REG(TSIx->CFGR, TSI_CFGR_NORMAVGODR_Msk, order);
}

/**
  * @brief
  * @rmtoll   CFGR    NORMAVGODR    FL_TSI_GetNormSensorAverageFilterOrder
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_NORM_AVGFILTER_ORDER_2X
  *           @arg @ref FL_TSI_NORM_AVGFILTER_ORDER_4X
  *           @arg @ref FL_TSI_NORM_AVGFILTER_ORDER_8X
  *           @arg @ref FL_TSI_NORM_AVGFILTER_ORDER_16X
  */
__STATIC_INLINE uint32_t FL_TSI_GetNormSensorAverageFilterOrder(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_NORMAVGODR_Msk));
}

/**
  * @brief
  * @rmtoll   CFGR    TRGSEL    FL_TSI_SetTriggerInput
  * @param    TSIx TSI instance
  * @param    trigger This parameter can be one of the following values:
  *           @arg @ref FL_TSI_TRGI_RTC
  *           @arg @ref FL_TSI_TRGI_ATIM
  *           @arg @ref FL_TSI_TRGI_LPTIM16
  *           @arg @ref FL_TSI_TRGI_BSTIM16
  *           @arg @ref FL_TSI_TRGI_TAU00
  *           @arg @ref FL_TSI_TRGI_TAU01
  *           @arg @ref FL_TSI_TRGI_TAU02
  *           @arg @ref FL_TSI_TRGI_TAU03
  *           @arg @ref FL_TSI_TRGI_TAU04
  *           @arg @ref FL_TSI_TRGI_TAU05
  *           @arg @ref FL_TSI_TRGI_TAU06
  *           @arg @ref FL_TSI_TRGI_TAU07
  *           @arg @ref FL_TSI_TRGI_TAU10
  *           @arg @ref FL_TSI_TRGI_TAU11
  *           @arg @ref FL_TSI_TRGI_TAU12
  *           @arg @ref FL_TSI_TRGI_TAU13
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetTriggerInput(TSI_Type *TSIx, uint32_t trigger)
{
    MODIFY_REG(TSIx->CFGR, TSI_CFGR_TRGSEL_Msk, trigger);
}

/**
  * @brief
  * @rmtoll   CFGR    TRGSEL    FL_TSI_GetTriggerInput
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_TRGI_RTC
  *           @arg @ref FL_TSI_TRGI_ATIM
  *           @arg @ref FL_TSI_TRGI_LPTIM16
  *           @arg @ref FL_TSI_TRGI_BSTIM16
  *           @arg @ref FL_TSI_TRGI_TAU00
  *           @arg @ref FL_TSI_TRGI_TAU01
  *           @arg @ref FL_TSI_TRGI_TAU02
  *           @arg @ref FL_TSI_TRGI_TAU03
  *           @arg @ref FL_TSI_TRGI_TAU04
  *           @arg @ref FL_TSI_TRGI_TAU05
  *           @arg @ref FL_TSI_TRGI_TAU06
  *           @arg @ref FL_TSI_TRGI_TAU07
  *           @arg @ref FL_TSI_TRGI_TAU10
  *           @arg @ref FL_TSI_TRGI_TAU11
  *           @arg @ref FL_TSI_TRGI_TAU12
  *           @arg @ref FL_TSI_TRGI_TAU13
  */
__STATIC_INLINE uint32_t FL_TSI_GetTriggerInput(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_TRGSEL_Msk));
}

/**
  * @brief
  * @rmtoll   CFGR    STOPMOD    FL_TSI_SetStopMode
  * @param    TSIx TSI instance
  * @param    mode This parameter can be one of the following values:
  *           @arg @ref FL_TSI_STOP_MODE_IMMEDIATELY
  *           @arg @ref FL_TSI_STOP_MODE_WAIT_IDLE
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetStopMode(TSI_Type *TSIx, uint32_t mode)
{
    MODIFY_REG(TSIx->CFGR, TSI_CFGR_STOPMOD_Msk, mode);
}

/**
  * @brief
  * @rmtoll   CFGR    STOPMOD    FL_TSI_GetStopMode
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_STOP_MODE_IMMEDIATELY
  *           @arg @ref FL_TSI_STOP_MODE_WAIT_IDLE
  */
__STATIC_INLINE uint32_t FL_TSI_GetStopMode(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_STOPMOD_Msk));
}

/**
  * @brief
  * @rmtoll   CFGR    TMOD    FL_TSI_SetTriggerMode
  * @param    TSIx TSI instance
  * @param    mode This parameter can be one of the following values:
  *           @arg @ref FL_TSI_TRIG_MODE_SOFTWARE
  *           @arg @ref FL_TSI_TRIG_MODE_TRGI
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetTriggerMode(TSI_Type *TSIx, uint32_t mode)
{
    MODIFY_REG(TSIx->CFGR, TSI_CFGR_TMOD_Msk, mode);
}

/**
  * @brief
  * @rmtoll   CFGR    TMOD    FL_TSI_GetTriggerMode
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_TRIG_MODE_SOFTWARE
  *           @arg @ref FL_TSI_TRIG_MODE_TRGI
  */
__STATIC_INLINE uint32_t FL_TSI_GetTriggerMode(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_TMOD_Msk));
}

/**
  * @brief
  * @rmtoll   CFGR    SHIELDEN    FL_TSI_EnableShield
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_EnableShield(TSI_Type *TSIx)
{
    SET_BIT(TSIx->CFGR, TSI_CFGR_SHIELDEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    SHIELDEN    FL_TSI_DisableShield
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_DisableShield(TSI_Type *TSIx)
{
    CLEAR_BIT(TSIx->CFGR, TSI_CFGR_SHIELDEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    SHIELDEN    FL_TSI_IsEnabledShield
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsEnabledShield(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_SHIELDEN_Msk) == TSI_CFGR_SHIELDEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    GUARDEN    FL_TSI_EnableGuardSensor
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_EnableGuardSensor(TSI_Type *TSIx)
{
    SET_BIT(TSIx->CFGR, TSI_CFGR_GUARDEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    GUARDEN    FL_TSI_DisableGuardSensor
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_DisableGuardSensor(TSI_Type *TSIx)
{
    CLEAR_BIT(TSIx->CFGR, TSI_CFGR_GUARDEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    GUARDEN    FL_TSI_IsEnabledGuardSensor
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsEnabledGuardSensor(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_GUARDEN_Msk) == TSI_CFGR_GUARDEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    PROXMOD    FL_TSI_SetNormSensorModeOnProx
  * @param    TSIx TSI instance
  * @param    mode This parameter can be one of the following values:
  *           @arg @ref FL_TSI_NORM_MODE_ON_PROX_CONTINUE
  *           @arg @ref FL_TSI_NORM_MODE_ON_PROX_STOP
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetNormSensorModeOnProx(TSI_Type *TSIx, uint32_t mode)
{
    MODIFY_REG(TSIx->CFGR, TSI_CFGR_PROXMOD_Msk, mode);
}

/**
  * @brief
  * @rmtoll   CFGR    PROXMOD    FL_TSI_GetNormSensorModeOnProx
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_NORM_MODE_ON_PROX_CONTINUE
  *           @arg @ref FL_TSI_NORM_MODE_ON_PROX_STOP
  */
__STATIC_INLINE uint32_t FL_TSI_GetNormSensorModeOnProx(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_PROXMOD_Msk));
}

/**
  * @brief
  * @rmtoll   CFGR    PROXEN    FL_TSI_EnableProxSensor
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_EnableProxSensor(TSI_Type *TSIx)
{
    SET_BIT(TSIx->CFGR, TSI_CFGR_PROXEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    PROXEN    FL_TSI_DisableProxSensor
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_DisableProxSensor(TSI_Type *TSIx)
{
    CLEAR_BIT(TSIx->CFGR, TSI_CFGR_PROXEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    PROXEN    FL_TSI_IsEnabledProxSensor
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsEnabledProxSensor(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_PROXEN_Msk) == TSI_CFGR_PROXEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    SEN    FL_TSI_Enable
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_Enable(TSI_Type *TSIx)
{
    SET_BIT(TSIx->CFGR, TSI_CFGR_SEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    SEN    FL_TSI_Disable
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_Disable(TSI_Type *TSIx)
{
    CLEAR_BIT(TSIx->CFGR, TSI_CFGR_SEN_Msk);
}

/**
  * @brief
  * @rmtoll   CFGR    SEN    FL_TSI_IsEnabled
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsEnabled(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CFGR, TSI_CFGR_SEN_Msk) == TSI_CFGR_SEN_Msk);
}

/**
  * @brief
  * @rmtoll   CR    START    FL_TSI_EnableScan
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_EnableScan(TSI_Type *TSIx)
{
    SET_BIT(TSIx->CR, TSI_CR_START_Msk);
}

/**
  * @brief
  * @rmtoll   CHCFGR    PROXCHEN    FL_TSI_SetProxSensorChannel
  * @param    TSIx TSI instance
  * @param    channel This parameter can be one of the following values:
  *           @arg @ref FL_TSI_BIT_CHANNEL_0
  *           @arg @ref FL_TSI_BIT_CHANNEL_1
  *           @arg @ref FL_TSI_BIT_CHANNEL_2
  *           @arg @ref FL_TSI_BIT_CHANNEL_3
  *           @arg @ref FL_TSI_BIT_CHANNEL_4
  *           @arg @ref FL_TSI_BIT_CHANNEL_5
  *           @arg @ref FL_TSI_BIT_CHANNEL_6
  *           @arg @ref FL_TSI_BIT_CHANNEL_7
  *           @arg @ref FL_TSI_BIT_CHANNEL_8
  *           @arg @ref FL_TSI_BIT_CHANNEL_9
  *           @arg @ref FL_TSI_BIT_CHANNEL_10
  *           @arg @ref FL_TSI_BIT_CHANNEL_11
  *           @arg @ref FL_TSI_BIT_CHANNEL_12
  *           @arg @ref FL_TSI_BIT_CHANNEL_13
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetProxSensorChannel(TSI_Type *TSIx, uint32_t channel)
{
    MODIFY_REG(TSIx->CHCFGR, TSI_CHCFGR_PROXCHEN_Msk, channel);
}

/**
  * @brief
  * @rmtoll   CHCFGR    PROXCHEN    FL_TSI_GetProxSensorChannel
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  */
__STATIC_INLINE uint32_t FL_TSI_GetProxSensorChannel(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CHCFGR, TSI_CHCFGR_PROXCHEN_Msk));
}

/**
  * @brief
  * @rmtoll   CHCFGR    NORMCHEN    FL_TSI_SetNormSensorChannel
  * @param    TSIx TSI instance
  * @param    channel This parameter can be one of the following values:
  *           @arg @ref FL_TSI_BIT_CHANNEL_0
  *           @arg @ref FL_TSI_BIT_CHANNEL_1
  *           @arg @ref FL_TSI_BIT_CHANNEL_2
  *           @arg @ref FL_TSI_BIT_CHANNEL_3
  *           @arg @ref FL_TSI_BIT_CHANNEL_4
  *           @arg @ref FL_TSI_BIT_CHANNEL_5
  *           @arg @ref FL_TSI_BIT_CHANNEL_6
  *           @arg @ref FL_TSI_BIT_CHANNEL_7
  *           @arg @ref FL_TSI_BIT_CHANNEL_8
  *           @arg @ref FL_TSI_BIT_CHANNEL_9
  *           @arg @ref FL_TSI_BIT_CHANNEL_10
  *           @arg @ref FL_TSI_BIT_CHANNEL_11
  *           @arg @ref FL_TSI_BIT_CHANNEL_12
  *           @arg @ref FL_TSI_BIT_CHANNEL_13
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetNormSensorChannel(TSI_Type *TSIx, uint32_t channel)
{
    MODIFY_REG(TSIx->CHCFGR, TSI_CHCFGR_NORMCHEN_Msk, channel);
}

/**
  * @brief
  * @rmtoll   CHCFGR    NORMCHEN    FL_TSI_GetNormSensorChannel
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  */
__STATIC_INLINE uint32_t FL_TSI_GetNormSensorChannel(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CHCFGR, TSI_CHCFGR_NORMCHEN_Msk));
}

/**
  * @brief
  * @rmtoll   CNTR    SID    FL_TSI_GetRawCountChannel
  * @param    TSIx TSI instance
  * @retval
  */
__STATIC_INLINE uint32_t FL_TSI_GetRawCountChannel(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CNTR, (0xfU << 16U)) >> 16U);
}

/**
  * @brief
  * @rmtoll   CNTR    RAWCNT    FL_TSI_ReadRawCount
  * @param    TSIx TSI instance
  * @retval
  */
__STATIC_INLINE uint32_t FL_TSI_ReadRawCount(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CNTR, (0xffffU << 0U)) >> 0U);
}

/**
  * @brief
  * @rmtoll   CCR    PRS    FL_TSI_SetSampleClockSource
  * @param    TSIx TSI instance
  * @param    source This parameter can be one of the following values:
  *           @arg @ref FL_TSI_SAMPLE_CLK_SOURCE_FIXED_CLK
  *           @arg @ref FL_TSI_SAMPLE_CLK_SOURCE_PRS_CLK
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetSampleClockSource(TSI_Type *TSIx, uint32_t source)
{
    MODIFY_REG(TSIx->CCR, TSI_CCR_PRS_Msk, source);
}

/**
  * @brief
  * @rmtoll   CCR    PRS    FL_TSI_GetSampleClockSource
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_SAMPLE_CLK_SOURCE_FIXED_CLK
  *           @arg @ref FL_TSI_SAMPLE_CLK_SOURCE_PRS_CLK
  */
__STATIC_INLINE uint32_t FL_TSI_GetSampleClockSource(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CCR, TSI_CCR_PRS_Msk));
}

/**
  * @brief
  * @rmtoll   CCR    SCANPRD    FL_TSI_WriteScanPeriod
  * @param    TSIx TSI instance
  * @param    period
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_WriteScanPeriod(TSI_Type *TSIx, uint32_t period)
{
    MODIFY_REG(TSIx->CCR, (0x1fU << 1U), (period << 1U));
}

/**
  * @brief
  * @rmtoll   CCR    SCANPRD    FL_TSI_ReadScanPeriod
  * @param    TSIx TSI instance
  * @retval
  */
__STATIC_INLINE uint32_t FL_TSI_ReadScanPeriod(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CCR, (0x1fU << 1U)) >> 1U);
}

/**
  * @brief
  * @rmtoll   CCR    SCANINTV    FL_TSI_WriteScanIntervalTime
  * @param    TSIx TSI instance
  * @param    period
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_WriteScanIntervalTime(TSI_Type *TSIx, uint32_t period)
{
    MODIFY_REG(TSIx->CCR, (0xffU << 8U), (period << 8U));
}

/**
  * @brief
  * @rmtoll   CCR    SCANINTV    FL_TSI_ReadScanIntervalTime
  * @param    TSIx TSI instance
  * @retval
  */
__STATIC_INLINE uint32_t FL_TSI_ReadScanIntervalTime(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CCR, (0xffU << 8U)) >> 8U);
}

/**
  * @brief
  * @rmtoll   CCR    SCANIDLE    FL_TSI_WriteScanIdleTime
  * @param    TSIx TSI instance
  * @param    time
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_WriteScanIdleTime(TSI_Type *TSIx, uint32_t time)
{
    MODIFY_REG(TSIx->CCR, (0xffU << 16U), (time << 16U));
}

/**
  * @brief
  * @rmtoll   CCR    SCANIDLE    FL_TSI_ReadScanIdleTime
  * @param    TSIx TSI instance
  * @retval
  */
__STATIC_INLINE uint32_t FL_TSI_ReadScanIdleTime(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->CCR, (0xffU << 16U)) >> 16U);
}

/**
  * @brief
  * @rmtoll   DMACR    DMAEN    FL_TSI_EnableDMAReq
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_EnableDMAReq(TSI_Type *TSIx)
{
    SET_BIT(TSIx->DMACR, TSI_DMACR_DMAEN_Msk);
}

/**
  * @brief
  * @rmtoll   CHCFGR    RES    FL_TSI_SetResolution
  * @param    TSIx TSI instance
  * @param    resolution This parameter can be one of the following values:
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_8B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_9B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_10B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_11B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_12B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_13B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_14B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_15B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_16B
  * @param    channel This parameter can be one of the following values:
  *           @arg @ref FL_TSI_CHANNEL_0
  *           @arg @ref FL_TSI_CHANNEL_1
  *           @arg @ref FL_TSI_CHANNEL_2
  *           @arg @ref FL_TSI_CHANNEL_3
  *           @arg @ref FL_TSI_CHANNEL_4
  *           @arg @ref FL_TSI_CHANNEL_5
  *           @arg @ref FL_TSI_CHANNEL_6
  *           @arg @ref FL_TSI_CHANNEL_7
  *           @arg @ref FL_TSI_CHANNEL_8
  *           @arg @ref FL_TSI_CHANNEL_9
  *           @arg @ref FL_TSI_CHANNEL_10
  *           @arg @ref FL_TSI_CHANNEL_11
  *           @arg @ref FL_TSI_CHANNEL_12
  *           @arg @ref FL_TSI_CHANNEL_13
  *           @arg @ref FL_TSI_CHANNEL_PROX
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetResolution(TSI_Type *TSIx, uint32_t resolution, uint32_t channel)
{
    MODIFY_REG(*((&TSIx->CH0CFGR) + channel), (0xfU << TSI_CHCFGR_RES_Pos), (resolution));
}

/**
  * @brief
  * @rmtoll   CHCFGR    RES    FL_TSI_GetResolution
  * @param    TSIx TSI instance
  * @param    channel This parameter can be one of the following values:
  *           @arg @ref FL_TSI_CHANNEL_0
  *           @arg @ref FL_TSI_CHANNEL_1
  *           @arg @ref FL_TSI_CHANNEL_2
  *           @arg @ref FL_TSI_CHANNEL_3
  *           @arg @ref FL_TSI_CHANNEL_4
  *           @arg @ref FL_TSI_CHANNEL_5
  *           @arg @ref FL_TSI_CHANNEL_6
  *           @arg @ref FL_TSI_CHANNEL_7
  *           @arg @ref FL_TSI_CHANNEL_8
  *           @arg @ref FL_TSI_CHANNEL_9
  *           @arg @ref FL_TSI_CHANNEL_10
  *           @arg @ref FL_TSI_CHANNEL_11
  *           @arg @ref FL_TSI_CHANNEL_12
  *           @arg @ref FL_TSI_CHANNEL_13
  *           @arg @ref FL_TSI_CHANNEL_PROX
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_8B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_9B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_10B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_11B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_12B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_13B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_14B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_15B
  *           @arg @ref FL_TSI_SAMPLE_RESOLUTION_16B
  */
__STATIC_INLINE uint32_t FL_TSI_GetResolution(TSI_Type *TSIx, uint32_t channel)
{
    return READ_BIT(*((&TSIx->CH0CFGR) + channel), (0xfU << TSI_CHCFGR_RES_Pos));
}

/**
  * @brief
  * @rmtoll   CHCFGR    FSW    FL_TSI_SetSampleClockPrescaler
  * @param    TSIx TSI instance
  * @param    psc This parameter can be one of the following values:
  *           @arg @ref FL_TSI_SAMPLE_PSC_DIV1
  *           @arg @ref FL_TSI_SAMPLE_PSC_DIV2
  *           @arg @ref FL_TSI_SAMPLE_PSC_DIV4
  *           @arg @ref FL_TSI_SAMPLE_PSC_DIV8
  *           @arg @ref FL_TSI_SAMPLE_PSC_DIV16
  *           @arg @ref FL_TSI_SAMPLE_PSC_DIV32
  * @param    channel This parameter can be one of the following values:
  *           @arg @ref FL_TSI_CHANNEL_0
  *           @arg @ref FL_TSI_CHANNEL_1
  *           @arg @ref FL_TSI_CHANNEL_2
  *           @arg @ref FL_TSI_CHANNEL_3
  *           @arg @ref FL_TSI_CHANNEL_4
  *           @arg @ref FL_TSI_CHANNEL_5
  *           @arg @ref FL_TSI_CHANNEL_6
  *           @arg @ref FL_TSI_CHANNEL_7
  *           @arg @ref FL_TSI_CHANNEL_8
  *           @arg @ref FL_TSI_CHANNEL_9
  *           @arg @ref FL_TSI_CHANNEL_10
  *           @arg @ref FL_TSI_CHANNEL_11
  *           @arg @ref FL_TSI_CHANNEL_12
  *           @arg @ref FL_TSI_CHANNEL_13
  *           @arg @ref FL_TSI_CHANNEL_PROX
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetSampleClockPrescaler(TSI_Type *TSIx, uint32_t psc, uint32_t channel)
{
    MODIFY_REG(*((&TSIx->CH0CFGR) + channel), (0x7U << TSI_CHCFGR_FSW_Pos), (psc));
}

/**
  * @brief
  * @rmtoll   CHCFGR    FSW    FL_TSI_GetSampleClockPrescaler
  * @param    TSIx TSI instance
  * @param    channel This parameter can be one of the following values:
  *           @arg @ref FL_TSI_CHANNEL_0
  *           @arg @ref FL_TSI_CHANNEL_1
  *           @arg @ref FL_TSI_CHANNEL_2
  *           @arg @ref FL_TSI_CHANNEL_3
  *           @arg @ref FL_TSI_CHANNEL_4
  *           @arg @ref FL_TSI_CHANNEL_5
  *           @arg @ref FL_TSI_CHANNEL_6
  *           @arg @ref FL_TSI_CHANNEL_7
  *           @arg @ref FL_TSI_CHANNEL_8
  *           @arg @ref FL_TSI_CHANNEL_9
  *           @arg @ref FL_TSI_CHANNEL_10
  *           @arg @ref FL_TSI_CHANNEL_11
  *           @arg @ref FL_TSI_CHANNEL_12
  *           @arg @ref FL_TSI_CHANNEL_13
  *           @arg @ref FL_TSI_CHANNEL_PROX
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_SAMPLE_PSC_DIV1
  *           @arg @ref FL_TSI_SAMPLE_PSC_DIV2
  *           @arg @ref FL_TSI_SAMPLE_PSC_DIV4
  *           @arg @ref FL_TSI_SAMPLE_PSC_DIV8
  *           @arg @ref FL_TSI_SAMPLE_PSC_DIV16
  *           @arg @ref FL_TSI_SAMPLE_PSC_DIV32
  */
__STATIC_INLINE uint32_t FL_TSI_GetSampleClockPrescaler(TSI_Type *TSIx, uint32_t channel)
{
    return READ_BIT(*((&TSIx->CH0CFGR) + channel), (0x7U << TSI_CHCFGR_FSW_Pos));
}

/**
  * @brief
  * @rmtoll   CHCFGR    IDAC    FL_TSI_SetIDACMode
  * @param    TSIx TSI instance
  * @param    mode This parameter can be one of the following values:
  *           @arg @ref FL_TSI_IDAC_MODE_SINGLE
  *           @arg @ref FL_TSI_IDAC_MODE_DUAL
  * @param    channel This parameter can be one of the following values:
  *           @arg @ref FL_TSI_CHANNEL_0
  *           @arg @ref FL_TSI_CHANNEL_1
  *           @arg @ref FL_TSI_CHANNEL_2
  *           @arg @ref FL_TSI_CHANNEL_3
  *           @arg @ref FL_TSI_CHANNEL_4
  *           @arg @ref FL_TSI_CHANNEL_5
  *           @arg @ref FL_TSI_CHANNEL_6
  *           @arg @ref FL_TSI_CHANNEL_7
  *           @arg @ref FL_TSI_CHANNEL_8
  *           @arg @ref FL_TSI_CHANNEL_9
  *           @arg @ref FL_TSI_CHANNEL_10
  *           @arg @ref FL_TSI_CHANNEL_11
  *           @arg @ref FL_TSI_CHANNEL_12
  *           @arg @ref FL_TSI_CHANNEL_13
  *           @arg @ref FL_TSI_CHANNEL_PROX
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetIDACMode(TSI_Type *TSIx, uint32_t mode, uint32_t channel)
{
    MODIFY_REG(*((&TSIx->CH0CFGR) + channel), (0x1U << TSI_CHCFGR_IDAC_Pos), (mode));
}

/**
  * @brief
  * @rmtoll   CHCFGR    IDAC    FL_TSI_GetIDACMode
  * @param    TSIx TSI instance
  * @param    channel This parameter can be one of the following values:
  *           @arg @ref FL_TSI_CHANNEL_0
  *           @arg @ref FL_TSI_CHANNEL_1
  *           @arg @ref FL_TSI_CHANNEL_2
  *           @arg @ref FL_TSI_CHANNEL_3
  *           @arg @ref FL_TSI_CHANNEL_4
  *           @arg @ref FL_TSI_CHANNEL_5
  *           @arg @ref FL_TSI_CHANNEL_6
  *           @arg @ref FL_TSI_CHANNEL_7
  *           @arg @ref FL_TSI_CHANNEL_8
  *           @arg @ref FL_TSI_CHANNEL_9
  *           @arg @ref FL_TSI_CHANNEL_10
  *           @arg @ref FL_TSI_CHANNEL_11
  *           @arg @ref FL_TSI_CHANNEL_12
  *           @arg @ref FL_TSI_CHANNEL_13
  *           @arg @ref FL_TSI_CHANNEL_PROX
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_IDAC_MODE_SINGLE
  *           @arg @ref FL_TSI_IDAC_MODE_DUAL
  */
__STATIC_INLINE uint32_t FL_TSI_GetIDACMode(TSI_Type *TSIx, uint32_t channel)
{
    return READ_BIT(*((&TSIx->CH0CFGR) + channel), (0x1U << TSI_CHCFGR_IDAC_Pos));
}

/**
  * @brief
  * @rmtoll   CHCFGR    IDAC1CFG    FL_TSI_WriteMasterIDACCurrent
  * @param    TSIx TSI instance
  * @param    current This parameter can be values between 0x00 - 0x7F
  * @param    channel This parameter can be one of the following values:
  *           @arg @ref FL_TSI_CHANNEL_0
  *           @arg @ref FL_TSI_CHANNEL_1
  *           @arg @ref FL_TSI_CHANNEL_2
  *           @arg @ref FL_TSI_CHANNEL_3
  *           @arg @ref FL_TSI_CHANNEL_4
  *           @arg @ref FL_TSI_CHANNEL_5
  *           @arg @ref FL_TSI_CHANNEL_6
  *           @arg @ref FL_TSI_CHANNEL_7
  *           @arg @ref FL_TSI_CHANNEL_8
  *           @arg @ref FL_TSI_CHANNEL_9
  *           @arg @ref FL_TSI_CHANNEL_10
  *           @arg @ref FL_TSI_CHANNEL_11
  *           @arg @ref FL_TSI_CHANNEL_12
  *           @arg @ref FL_TSI_CHANNEL_13
  *           @arg @ref FL_TSI_CHANNEL_PROX
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_WriteMasterIDACCurrent(TSI_Type *TSIx, uint32_t current, uint32_t channel)
{
    MODIFY_REG(*((&TSIx->CH0CFGR) + channel), (0x7fU << TSI_CHCFGR_IDAC1CFG_Pos), (current << TSI_CHCFGR_IDAC1CFG_Pos));
}

/**
  * @brief
  * @rmtoll   CHCFGR    IDAC1CFG    FL_TSI_ReadMasterIDACCurrent
  * @param    TSIx TSI instance
  * @param    channel This parameter can be one of the following values:
  *           @arg @ref FL_TSI_CHANNEL_0
  *           @arg @ref FL_TSI_CHANNEL_1
  *           @arg @ref FL_TSI_CHANNEL_2
  *           @arg @ref FL_TSI_CHANNEL_3
  *           @arg @ref FL_TSI_CHANNEL_4
  *           @arg @ref FL_TSI_CHANNEL_5
  *           @arg @ref FL_TSI_CHANNEL_6
  *           @arg @ref FL_TSI_CHANNEL_7
  *           @arg @ref FL_TSI_CHANNEL_8
  *           @arg @ref FL_TSI_CHANNEL_9
  *           @arg @ref FL_TSI_CHANNEL_10
  *           @arg @ref FL_TSI_CHANNEL_11
  *           @arg @ref FL_TSI_CHANNEL_12
  *           @arg @ref FL_TSI_CHANNEL_13
  *           @arg @ref FL_TSI_CHANNEL_PROX
  * @retval   Returned value can be values between 0x00 - 0x7F
  */
__STATIC_INLINE uint32_t FL_TSI_ReadMasterIDACCurrent(TSI_Type *TSIx, uint32_t channel)
{
    return (READ_BIT(*((&TSIx->CH0CFGR) + channel), (0x7fU << TSI_CHCFGR_IDAC1CFG_Pos)) >> TSI_CHCFGR_IDAC1CFG_Pos);
}

/**
  * @brief
  * @rmtoll   CHCFGR    IDAC2CFG    FL_TSI_WriteCompensateIDACCurrent
  * @param    TSIx TSI instance
  * @param    current This parameter can be values between 0x00 - 0x7F
  * @param    channel This parameter can be one of the following values:
  *           @arg @ref FL_TSI_CHANNEL_0
  *           @arg @ref FL_TSI_CHANNEL_1
  *           @arg @ref FL_TSI_CHANNEL_2
  *           @arg @ref FL_TSI_CHANNEL_3
  *           @arg @ref FL_TSI_CHANNEL_4
  *           @arg @ref FL_TSI_CHANNEL_5
  *           @arg @ref FL_TSI_CHANNEL_6
  *           @arg @ref FL_TSI_CHANNEL_7
  *           @arg @ref FL_TSI_CHANNEL_8
  *           @arg @ref FL_TSI_CHANNEL_9
  *           @arg @ref FL_TSI_CHANNEL_10
  *           @arg @ref FL_TSI_CHANNEL_11
  *           @arg @ref FL_TSI_CHANNEL_12
  *           @arg @ref FL_TSI_CHANNEL_13
  *           @arg @ref FL_TSI_CHANNEL_PROX
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_WriteCompensateIDACCurrent(TSI_Type *TSIx, uint32_t current, uint32_t channel)
{
    MODIFY_REG(*((&TSIx->CH0CFGR) + channel), (0x7fU << TSI_CHCFGR_IDAC2CFG_Pos), (current << TSI_CHCFGR_IDAC2CFG_Pos));
}

/**
  * @brief
  * @rmtoll   CHCFGR    IDAC2CFG    FL_TSI_ReadCompensateIDACCurrent
  * @param    TSIx TSI instance
  * @param    channel This parameter can be one of the following values:
  *           @arg @ref FL_TSI_CHANNEL_0
  *           @arg @ref FL_TSI_CHANNEL_1
  *           @arg @ref FL_TSI_CHANNEL_2
  *           @arg @ref FL_TSI_CHANNEL_3
  *           @arg @ref FL_TSI_CHANNEL_4
  *           @arg @ref FL_TSI_CHANNEL_5
  *           @arg @ref FL_TSI_CHANNEL_6
  *           @arg @ref FL_TSI_CHANNEL_7
  *           @arg @ref FL_TSI_CHANNEL_8
  *           @arg @ref FL_TSI_CHANNEL_9
  *           @arg @ref FL_TSI_CHANNEL_10
  *           @arg @ref FL_TSI_CHANNEL_11
  *           @arg @ref FL_TSI_CHANNEL_12
  *           @arg @ref FL_TSI_CHANNEL_13
  *           @arg @ref FL_TSI_CHANNEL_PROX
  * @retval   Returned value can be values between 0x00 - 0x7F
  */
__STATIC_INLINE uint32_t FL_TSI_ReadCompensateIDACCurrent(TSI_Type *TSIx, uint32_t channel)
{
    return (READ_BIT(*((&TSIx->CH0CFGR) + channel), (0x7fU << TSI_CHCFGR_IDAC2CFG_Pos)) >> TSI_CHCFGR_IDAC2CFG_Pos);
}

/**
  * @brief
  * @rmtoll   IDACTR    IDAC2TR    FL_TSI_WriteCompensateIDACTrimValue
  * @param    TSIx TSI instance
  * @param    trim
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_WriteCompensateIDACTrimValue(TSI_Type *TSIx, uint32_t trim)
{
    MODIFY_REG(TSIx->IDACTR, (0x1fU << 8U), (trim << 8U));
}

/**
  * @brief
  * @rmtoll   IDACTR    IDAC2TR    FL_TSI_ReadCompensateIDACTrimValue
  * @param    TSIx TSI instance
  * @retval
  */
__STATIC_INLINE uint32_t FL_TSI_ReadCompensateIDACTrimValue(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->IDACTR, (0x1fU << 8U)) >> 8U);
}

/**
  * @brief
  * @rmtoll   IDACTR    IDAC1TR    FL_TSI_WriteMasterIDACTrimValue
  * @param    TSIx TSI instance
  * @param    trim
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_WriteMasterIDACTrimValue(TSI_Type *TSIx, uint32_t trim)
{
    MODIFY_REG(TSIx->IDACTR, (0x1fU << 0U), (trim << 0U));
}

/**
  * @brief
  * @rmtoll   IDACTR    IDAC1TR    FL_TSI_ReadMasterIDACTrimValue
  * @param    TSIx TSI instance
  * @retval
  */
__STATIC_INLINE uint32_t FL_TSI_ReadMasterIDACTrimValue(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->IDACTR, (0x1fU << 0U)) >> 0U);
}

/**
  * @brief
  * @rmtoll   ANACR    RCBYP    FL_TSI_EnableCompRC
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_EnableCompRC(TSI_Type *TSIx)
{
    CLEAR_BIT(TSIx->ANACR, TSI_ANACR_RCBYP_Msk);
}

/**
  * @brief
  * @rmtoll   ANACR    RCBYP    FL_TSI_DisableCompRC
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_DisableCompRC(TSI_Type *TSIx)
{
    CLEAR_BIT(TSIx->ANACR, TSI_ANACR_RCBYP_Msk);
}

/**
  * @brief
  * @rmtoll   ANACR    RCBYP    FL_TSI_IsEnabledCompRC
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsEnabledCompRC(TSI_Type *TSIx)
{
    return (uint32_t)!(READ_BIT(TSIx->ANACR, TSI_ANACR_RCBYP_Msk) == TSI_ANACR_RCBYP_Msk);
}

/**
  * @brief
  * @rmtoll   ANACR    CMPRC    FL_TSI_SetCompRCBandwidth
  * @param    TSIx TSI instance
  * @param    bandwidth This parameter can be one of the following values:
  *           @arg @ref FL_TSI_COMP_RC_BANDWIDTH_1P48MHZ
  *           @arg @ref FL_TSI_COMP_RC_BANDWIDTH_0P529MHZ
  *           @arg @ref FL_TSI_COMP_RC_BANDWIDTH_0P4MHZ
  *           @arg @ref FL_TSI_COMP_RC_BANDWIDTH_0P293MHZ
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetCompRCBandwidth(TSI_Type *TSIx, uint32_t bandwidth)
{
    MODIFY_REG(TSIx->ANACR, TSI_ANACR_CMPRC_Msk, bandwidth);
}

/**
  * @brief
  * @rmtoll   ANACR    CMPRC    FL_TSI_GetCompRCBandwidth
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_COMP_RC_BANDWIDTH_1P48MHZ
  *           @arg @ref FL_TSI_COMP_RC_BANDWIDTH_0P529MHZ
  *           @arg @ref FL_TSI_COMP_RC_BANDWIDTH_0P4MHZ
  *           @arg @ref FL_TSI_COMP_RC_BANDWIDTH_0P293MHZ
  */
__STATIC_INLINE uint32_t FL_TSI_GetCompRCBandwidth(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->ANACR, TSI_ANACR_CMPRC_Msk));
}

/**
  * @brief
  * @rmtoll   ANACR    CMPHS    FL_TSI_EnableCompHighSpeed
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_EnableCompHighSpeed(TSI_Type *TSIx)
{
    SET_BIT(TSIx->ANACR, TSI_ANACR_CMPHS_Msk);
}

/**
  * @brief
  * @rmtoll   ANACR    CMPHS    FL_TSI_DisableCompHighSpeed
  * @param    TSIx TSI instance
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_DisableCompHighSpeed(TSI_Type *TSIx)
{
    CLEAR_BIT(TSIx->ANACR, TSI_ANACR_CMPHS_Msk);
}

/**
  * @brief
  * @rmtoll   ANACR    CMPHS    FL_TSI_IsEnabledCompHighSpeed
  * @param    TSIx TSI instance
  * @retval   State of bit (1 or 0).
  */
__STATIC_INLINE uint32_t FL_TSI_IsEnabledCompHighSpeed(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->ANACR, TSI_ANACR_CMPHS_Msk) == TSI_ANACR_CMPHS_Msk);
}

/**
  * @brief
  * @rmtoll   ANACR    VREFBUFCFG    FL_TSI_SetBufferDriverStrength
  * @param    TSIx TSI instance
  * @param    strength This parameter can be one of the following values:
  *           @arg @ref FL_TSI_BUFFER_DRIVER_STRENGTH_DISABLE
  *           @arg @ref FL_TSI_BUFFER_DRIVER_STRENGTH_LOW
  *           @arg @ref FL_TSI_BUFFER_DRIVER_STRENGTH_MEDIUM
  *           @arg @ref FL_TSI_BUFFER_DRIVER_STRENGTH_HIGH
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetBufferDriverStrength(TSI_Type *TSIx, uint32_t strength)
{
    MODIFY_REG(TSIx->ANACR, TSI_ANACR_VREFBUFCFG_Msk, strength);
}

/**
  * @brief
  * @rmtoll   ANACR    VREFBUFCFG    FL_TSI_GetBufferDriverStrength
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_BUFFER_DRIVER_STRENGTH_DISABLE
  *           @arg @ref FL_TSI_BUFFER_DRIVER_STRENGTH_LOW
  *           @arg @ref FL_TSI_BUFFER_DRIVER_STRENGTH_MEDIUM
  *           @arg @ref FL_TSI_BUFFER_DRIVER_STRENGTH_HIGH
  */
__STATIC_INLINE uint32_t FL_TSI_GetBufferDriverStrength(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->ANACR, TSI_ANACR_VREFBUFCFG_Msk));
}

/**
  * @brief
  * @rmtoll   TEST    CHIDLECFG    FL_TSI_SetInactiveSensorConnection
  * @param    TSIx TSI instance
  * @param    connection This parameter can be one of the following values:
  *           @arg @ref FL_TSI_INACTIVE_SENSOR_CONNECTION_FLOAT
  *           @arg @ref FL_TSI_INACTIVE_SENSOR_CONNECTION_GROUND
  * @retval   None
  */
__STATIC_INLINE void FL_TSI_SetInactiveSensorConnection(TSI_Type *TSIx, uint32_t connection)
{
    MODIFY_REG(TSIx->TEST, TSI_TEST_CHIDLECFG_Msk, connection);
}

/**
  * @brief
  * @rmtoll   TEST    CHIDLECFG    FL_TSI_GetInactiveSensorConnection
  * @param    TSIx TSI instance
  * @retval   Returned value can be one of the following values:
  *           @arg @ref FL_TSI_INACTIVE_SENSOR_CONNECTION_FLOAT
  *           @arg @ref FL_TSI_INACTIVE_SENSOR_CONNECTION_GROUND
  */
__STATIC_INLINE uint32_t FL_TSI_GetInactiveSensorConnection(TSI_Type *TSIx)
{
    return (uint32_t)(READ_BIT(TSIx->TEST, TSI_TEST_CHIDLECFG_Msk));
}

/**
  * @}
  */

/** @defgroup TSI_FL_EF_Init Initialization and de-initialization functions
  * @{
  */

FL_ErrorStatus FL_TSI_ModuleReset(void);

/**
  * @}
  */


/**
  * @}
  */

#ifdef __cplusplus
}
#endif

#endif /* __FM33FR0XX_FL_TSI_H*/

/*************************Py_Code_Generator Version: 0.1-0.14-0.1 @ 2021-11-19*************************/
/*************************(C) COPYRIGHT Fudan Microelectronics **** END OF FILE*************************/
