/**
  ****************************************************************************************************
  * @file    fm33fr0xx_fl_tsi.c
  * @author  FMSH Application Team
  * @brief   Src file of TSI FL Module
  ****************************************************************************************************
  * @attention
  *
  * Copyright (c) [2021] [Fudan Microelectronics]
  * THIS SOFTWARE is licensed under Mulan PSL v2.
  * You can use this software according to the terms and conditions of the Mulan PSL v2.
  * You may obtain a copy of Mulan PSL v2 at:
  *          http://license.coscl.org.cn/MulanPSL2
  * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
  * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
  * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
  * See the Mulan PSL v2 for more details.
  *
  ****************************************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "fm33fr0xx_fl.h"

/** @addtogroup FM33LC0XX_FL_Driver_TSI
  * @{
  */

/* Private macros ------------------------------------------------------------*/
/** @addtogroup TSI_FL_Private_Macros
  * @{
  */

/**
  * @}
  */

/** @addtogroup TSI_FL_EF_Init
  * @{
  */

/**
 * @brief
 */
FL_ErrorStatus FL_TSI_ModuleReset(void)
{
    FL_RMU_EnablePeripheralReset(RMU);
    FL_RMU_EnableResetAPBPeripheral(RMU, FL_RMU_RSTAPB_TSC);
    FL_RMU_DisableResetAPBPeripheral(RMU, FL_RMU_RSTAPB_TSC);
    FL_RMU_DisablePeripheralReset(RMU);
    return FL_PASS;
}

/**
  * @}
  */

/**
  * @}
  */
/*************************************************************END OF FILE************************************************************/
